package VR.data

import java.io.{OutputStreamWriter, File, PrintWriter}

import VR._

/**
  * Created by YY on 2016/1/23.
  */
class DataClass(content:Data_all_content_type, clusterFile:String) {
  val (x,y, n,d,tot_non_zero, avg_len):Data_all_content_type=content
  val belongTo:Array[Int]=DataProcessor.clusterReader(clusterFile, content)

  def this(file_loc:String, helper_loc:String, is_logistic:Boolean)=this(DataProcessor.dataReader(file_loc:String, helper_loc:String, is_logistic:Boolean),"")
  def this(file_loc:String, helper_loc:String, is_logistic:Boolean, clusterFile:String)=this(DataProcessor.dataReader(file_loc:String, helper_loc:String, is_logistic:Boolean),clusterFile)
  def this(content:Data_all_content_type)=this(content,"")
  def this(x:X_type, y:Y_type,n:Int, d:Int)=this((x,y,n,d,0,0),"")

  def create_new_instance(content:Data_all_content_type):DataClass=new DataClass(content)

  def get_contents():Data_all_content_type=(x,y,n,d,tot_non_zero,avg_len)
  def get_data():Data_mini_type=(x,y,n,d)

  def print_few(print_to_file:String="", helper_file:String=""):Unit= {
    val f_out=if (print_to_file=="") new OutputStreamWriter(System.out)
              else new PrintWriter(new File(print_to_file))
    for (tot <- x.indices) {
      f_out.write(y(tot) + " ")
      for (entry <- x(tot))
        f_out.write(entry._1 + ":" + entry._2 + " ")
      f_out.write("\n")
    }
    f_out.close()
    val f_helper_out=if (helper_file=="") new OutputStreamWriter(System.out)
    else new PrintWriter(new File(helper_file))
    f_helper_out.write(n+"\n"+"1\n")
    f_helper_out.close()
  }

}
