package VR.prob

import VR._
import VR.data.PCA_Data

/**
  * Created by YY on 2016/1/31.
  */
class PCA_Problem extends ProblemBase[PCA_Data]{


  override def binary_alpha_cal(alpha: Double, w: Array[Double], dat:PCA_Data, row:Int,lambda:Double,n:Int): Double = {
    println("PCA for SDCA not implemented.")
    assert(false)
    1.0
  }

  override def predict(w:Array[Double], x:Single_x_type): Int= {
    println("PCA for prediction not implemented.")
    assert(false)
    1
  }

  override protected def row_objective_cal(w:Array[Double], data:PCA_Data, row:Int):Double={
    0.5* sqr(inner_sparse(w,data.x(row)))+inner_sparse(w, data.random_b)
  }

  override def gradient_cal(w:Array[Double],dat:PCA_Data, row:Int):Array[Double]=  {
    val x=dat.x(row)
    val matrix_d:Row_type=dat.matrix_D(row)
    val output:Array[Double]=new Array[Double](dat.d)
    val multi:Double=inner_sparse(w, x)
    for (i<-Range(0, dat.d)){
      output(i)=matrix_d(i)* w(i)+ (x(i)._2 * multi)+dat.random_b(i)._2
    }
    output
  }
}
